﻿;-- TIME_STAMP   2019-05-13 01:33:14   v 0.1

#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
;~ #AutoIt3Wrapper_AU3Check_Parameters=-q -d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w- 7
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#Region    ;************ Includes ************
#include-once
#include <GUIConstantsEx.au3>
#include <WinAPIConstants.au3>
#include <TabConstants.au3>
#include <Process.au3>
#include <WinAPIConv.au3>
#Include <WindowsConstants.au3>
#include <WinAPISysWin.au3>
#include <SendMessage.au3>
#include <scintilla.h.au3>
#include <_SciTE_Constants.au3>
#include <_Print.au3>
#include <Memory.au3>
#include <WinAPIProc.au3>
#include <WinAPIMem.au3>
#include <WinAPIDiag.au3>
#EndRegion ;************ Includes ************

Global Enum $eSCI_NoWait, $eSCI_Wait
Global Enum $eSCI_EditorPane = 1, $eSCI_OutputPane

Global $g_SciTECmd, $SciTE_Interface_Debug = False

#cs  The actions understood by SciTE DirectorExtension are:
askfilename: 								Return the name of the file being edited.
askproperty:<key> 							Return the value of a property.
close: 										Close the current file.
closing: 									Director is closing - SciTE closes if it was started by the director.
currentmacro:<string> 						Set the current macro to name.
cwd: 										Change the working directory.
enumproperties:dyn|local|user|base|embed 	Enumerate all the properties in the argument set.
exportashtml:<path> 						Save the document in HTML format as the indicated file.
exportasrtf:<path> 							Save the document in RTF format as the indicated file.
exportaspdf:<path> 							Save the document in PDF format as the indicated file.
exportaslatex:<path> 						Save the document in LaTeX format as the indicated file.
exportasxml:<path> 							Save the document in XML format as the indicated file.
extender:<command> 							Call the extension interface with the given command.
find:<string> 								Search for a string, select and show it.
goto:<lineNumber>[,<columnNumber>] 			Move caret to a particular line and make it visible.
											If there is a column number then select the word at that column number or move the caret there if no word is present.
identity:<hwndDirector> 					Sets the director window handle to which SciTE sends messages. The argument is in decimal.
insert:<value> 								Display the value in the editor pane replacing the selection.
loadsession:<path>	 						Load a session as given by the indicated file.
macrocommand:<command> 						Execute a macro command. See the SciTE source code for the syntax of the command argument.
macroenable:<enable> 						If enable, display menu commands in SciTE for recording and playing macros.
macrolist:<list> 							Display a list for the user to choose from.
menucommand:<cmd> 							Execute a menu command based on numeric ID.
open:<path> 								Open the indicated file.
output:<value> 								Display the value in the output pane replacing the selection.
property:<key>=<value> 						Set a property to a value.
quit: 										Shut down SciTE.
reloadproperties: 							Reload properties from files.
replaceall:<search>\000<replace> 			Replace all instances of he search string in the document with the replace string.
saveas:<path> 								Save the document as the indicated file.
savesession:<path> 							Save a session as given by the indicated file.
#ce  The actions understood by SciTE are:

#cs  The actions understood by Scintilla are (many more as SciTE DirectorExtension!):
	See scintilla.h.au3
#ce

Local $iGUIRegisterMsg = GUIRegisterMsg(74, "_WM_COPYDATA")  ; $WM_COPYDATA = 74

;==================================================================================================
; Function Name....: _SciTE_GetHWndFromSciTE
; Description......: Gibt das Handle der angegebenen/zuletzt aktiven SciTE-Instanz zurück
; Parameter(s).....: $_vSciTE             - [optional] a variant value. Default is 1
; Return Value(s)..: Success: $_vSciTE = HWnd    - SciTE-HWnd
;                             $_vSciTE = Int > 0 - SciTE-HWnd der angegebenen Instanz
;                             $_vSciTE = Int = 0 - SciTE-HWnd der zuletzt aktiven Instanz
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetHWndFromSciTE($_vSciTE = $eSCI_EditorPane)
	Switch True
		Case IsHWnd($_vSciTE)
			$_vSciTE = _WinAPI_GetClassName($_vSciTE) = 'SciTEWindow' ? $_vSciTE : False
		Case IsInt($_vSciTE)
			$_vSciTE = ($_vSciTE = 0 ? WinGetHandle('[CLASS:SciTEWindow]') : WinGetHandle('[CLASS:SciTEWindow; Instance:'&$_vSciTE&']'))
		Case Else
			$_vSciTE = WinGetHandle('[CLASS:SciTEWindow]')
	EndSwitch
	Return SetError((IsHWnd($_vSciTE) ? 0 : 1), 0, (IsHWnd($_vSciTE) ? $_vSciTE : False))
EndFunc  ;==>_SciTE_GetHWndFromSciTE

;==================================================================================================
; Function Name....: _SciTE_GetHWndFromActivePane
; Description......: Gibt das Handle der aktiven Pane (Editor/Output) von $_hScITE zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: Success: HWnd der aktiven Pane
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetHWndFromActivePane($_hScITE = '')
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.

	Local $sFocus, $hActive, $hEditor = _SciTE_GetHWndFromEditor($_hScITE), $hOutput = _SciTE_GetHWndFromOutput($_hScITE)

	$hActive = WinGetHandle('[ACTIVE]')
	If $hActive <> $_hScITE Then
		; Z-Order?
;~ 		Local $hHWNDPREV = _WinAPI_GetWindow($_hScITE, $GW_HWNDPREV)
;~ 		_CW("$hHWNDPREV                 --> " & $hHWNDPREV & ' ' & _ProcessGetName(WinGetProcess($hHWNDPREV)))
		WinActivate($_hScITE)
		$sFocus = ControlGetFocus($_hScITE)
		WinActivate($hActive)
;~ 		_WinAPI_SetWindowPos
;~ 		_WinAPI_MonitorFromWindow
;~ 		_WinAPI_GetMonitorInfo
	Else
		$sFocus = ControlGetFocus($_hScITE)
	EndIf
	_CW("Focus                  --> " & $sFocus)

	Switch True
		Case IsHWnd($_hScITE) = 0
			Return SetError(1, 0, False)
		Case $sFocus = 'Scintilla1' ; Editor
			Return $hEditor
		Case $sFocus = 'Scintilla2' ; Output
			Return $hOutput
		Case Else
			Return SetError(1, 0, False)
	EndSwitch
EndFunc  ;==>_SciTE_GetHWndFromActivePane

;==================================================================================================
; Function Name....: _SciTE_GetHWndFromEditor
; Description......: Gibt das Handle der Editor-Pane von $_hScITE zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: Success: HWnd der Editor-Pane
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetHWndFromEditor($_hScITE = '')
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Return SetError((IsHWnd($_hScITE) ? 0 : 1), 0, (IsHWnd($_hScITE) ? ControlGetHandle($_hScITE, '', '[CLASS:Scintilla; INSTANCE:1]') : False))
EndFunc  ;==>_SciTE_GetHWndFromEditor

;==================================================================================================
; Function Name....: _SciTE_GetHWndFromOutput
; Description......: Gibt das Handle der Output-Pane on $_hScITE zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: Success: HWnd der Output-Pane
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetHWndFromOutput($_hScITE = '')
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Return SetError((IsHWnd($_hScITE) ? 0 : 1), 0, (IsHWnd($_hScITE) ? ControlGetHandle($_hScITE, '', '[CLASS:Scintilla; INSTANCE:2]') : False))
EndFunc  ;==>_SciTE_GetHWndFromOutput

;==================================================================================================
; Function Name....: _SciTE_GetTabCount
; Description......: Gibt die Anzahl der Tabs im Editor zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: Success: TabCount
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetTabCount($_hScITE = '')
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hTab = ControlGetHandle($_hScITE, '', '[CLASS:SciTeTabCtrl; INSTANCE:1]')
	Return SetError((IsHWnd($hTab) ? 0 : 1), 0, (IsHWnd($hTab) ? _SendMessage($hTab, $TCM_GETITEMCOUNT) : False))
EndFunc  ;==>_SciTE_GetTabCount

;==================================================================================================
; Function Name....: _SciTE_GetCurrentTabNumber
; Description......: Gibt die Nummer des aktuell aktiven Tab im Editor zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default ''
; Return Value(s)..: Success: TabNumber (0 based)
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetCurrentTabNumber($_hScITE = '')
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hTab = ControlGetHandle($_hScITE, '', '[CLASS:SciTeTabCtrl; INSTANCE:1]')
	Return SetError((IsHWnd($hTab) ? 0 : 1), 0, (IsHWnd($hTab) ? _SendMessage($hTab, $TCM_GETCURSEL) : False))
EndFunc  ;==>_SciTE_GetCurrentTabNumber

;==================================================================================================
; Function Name....: _SciTE_SetCurrentTabNumber
; Description......: Aktiviert den angegebenen Tab im Editor
; Parameter(s).....: $_iTabNumber         - a integer value. TabNumber (0 based)
;                    $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: Success: Previous active Tab (0 based)
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_SetCurrentTabNumber($_iTabNumber, $_hScITE = '') ; $iTabNumber (0 based)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
    Local $hTab = ControlGetHandle($_hScITE, '', '[CLASS:SciTeTabCtrl; INSTANCE:1]')
    _CW("$hTab                      --> " & $hTab)
    If Not IsHWnd($hTab) Then Return SetError(1, 0, False)
	Local $iLastItem = _SendMessage($hTab, $TCM_GETITEMCOUNT) -1
	Return _SendMessage($hTab, $TCM_SETCURSEL, $_iTabNumber > $iLastItem ? $iLastItem : $_iTabNumber)
EndFunc  ;==>_SciTE_SetCurrentTabNumber

;==================================================================================================
; Function Name....: _SciTE_GetCurrentPosition
; Description......: Gibt die aktuelle Position des Caret in der angegebenen Pane zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: Position des Caret (0 based)
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetCurrentPosition($_hScITE = '', $_iPane = $eSCI_EditorPane)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	Return SetError((IsHWnd($hPane) ? 0 : 1), 0, (IsHWnd($hPane) ? _SendMessage($hPane, $SCI_GETCURRENTPOS) : False))
EndFunc  ;==>_SciTE_GetCurrentPosition

;==================================================================================================
; Function Name....: _SciTE_GetSelection
; Description......: Gibt die Start-/Endposition des selektierten Textes in der angegebenen Pane zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: $aSELECTION - Start-/Endposition des selektierten Textes (0 based)
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetSelection($_hScITE = '', $_iPane = $eSCI_EditorPane)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	If Not IsHWnd($hPane) Then Return SetError(1, 0, False)
	Local $aSELECTION = [_SendMessage($hPane, $SCI_GETSELECTIONSTART), _SendMessage($hPane, $SCI_GETSELECTIONEND)]
	Return $aSELECTION
EndFunc  ;==>_SciTE_GetSelection

;==================================================================================================
; Function Name....: _SciTE_SetSelection
; Description......: Selektiert den Text an der angegebenen Start-/Endposition in der angegebenen Pane
; Parameter(s).....: $_iSelectionStart    - a integer value.
;                    $_iSelectionEnd      - a integer value.
;                    $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: None
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_SetSelection($_iSelectionStart, $_iSelectionEnd, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	If Not IsHWnd($hPane) Then Return SetError(1, 0, False)
	_SendMessage($hPane, $SCI_SETSELECTIONSTART, $_iSelectionStart)
	_SendMessage($hPane, $SCI_SETSELECTIONEND, $_iSelectionEnd)
EndFunc  ;==>_SciTE_SetSelection

;==================================================================================================
; Function Name....: _SciTE_GetSelectionStart
; Description......: Gibt die Startposition des selektierten Textes in der angegebenen Pane zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: Startposition des selektierten Textes (0 based)
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetSelectionStart($_hScITE = '', $_iPane = $eSCI_EditorPane)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	Return SetError((IsHWnd($hPane) ? 0 : 1), 0, (IsHWnd($hPane) ? _SendMessage($hPane, $SCI_GETSELECTIONSTART) : False))
EndFunc  ;==>_SciTE_GetSelectionStart

;==================================================================================================
; Function Name....: _SciTE_SetSelectionStart
; Description......: Setzt die Startposition für eine Text-Selektion in der angegebenen Pane
; Parameter(s).....: $_iSelectionStart    - a integer value.
;                    $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: None
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_SetSelectionStart($_iSelectionStart, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	Return SetError((IsHWnd($hPane) ? 0 : 1), 0, (IsHWnd($hPane) ? _SendMessage($hPane, $SCI_SETSELECTIONSTART, $_iSelectionStart) : False))
EndFunc  ;==>_SciTE_SetSelectionStart

;==================================================================================================
; Function Name....: _SciTE_GetSelectionEnd
; Description......: Gibt die Endposition des selektierten Textes in der angegebenen Pane zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: Endposition des selektierten Textes (0 based)
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetSelectionEnd($_hScITE = '', $_iPane = $eSCI_EditorPane)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	Return SetError((IsHWnd($hPane) ? 0 : 1), 0, (IsHWnd($hPane) ? _SendMessage($hPane, $SCI_GETSELECTIONEND) : False))
EndFunc  ;==>_SciTE_GetSelectionEnd

; Function Name....: _SciTE_SetSelectionEnd
; Description......: Setzt die Endposition für eine Text-Selektion in der angegebenen Pane
; Parameter(s).....: $_iSelectionEnd      - a integer value.
;                    $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: None
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_SetSelectionEnd($_iSelectionEnd, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	Return SetError((IsHWnd($hPane) ? 0 : 1), 0, (IsHWnd($hPane) ? _SendMessage($hPane, $SCI_SETSELECTIONEND, $_iSelectionEnd) : False))
EndFunc  ;==>_SciTE_SetSelectionEnd

;==================================================================================================
; Function Name....: _SciTE_GetLineCount
; Description......: Gibt die Anzahl der Zeilen in der angegebenen Pane zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: LineCount (0 based)
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetLineCount($_hScITE = '', $_iPane = $eSCI_EditorPane)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	Return SetError((IsHWnd($hPane) ? 0 : 1), 0, (IsHWnd($hPane) ? _SendMessage($hPane, $SCI_GETLINECOUNT) : False))
EndFunc  ;==>_SciTE_GetLineCount

; Function Name....: _SciTE_GetLineLength
; Description......: Gibt die Länge des Textes in der angegebenen Pane zurück
; Parameter(s).....: $_iLineNumber        - a integer value.
;                    $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: Länge des Textes
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetLineLength($_iLineNumber, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	If Not IsInt($_iLineNumber) Or $_iLineNumber < 0 Then Return SetError(1, 0, False)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	Return SetError((IsHWnd($hPane) ? 0 : 1), 0, (IsHWnd($hPane) ? _SendMessage($hPane, $SCI_LINELENGTH, $_iLineNumber) : False))
EndFunc  ;==>_SciTE_GetLineLength

; Function Name....: _SciTE_GetCharAt
; Description......: Gibt das Zeichen an der angegebenen Position in der angegebenen Pane zurück
; Parameter(s).....: $_iPosition          - a integer value.
;                    $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: Länge des Textes
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetCharAt($_iPosition, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	If Not IsInt($_iPosition) Or $_iPosition < 0 Then Return SetError(1, 0, False)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	Return SetError((IsHWnd($hPane) ? 0 : 1), 0, (IsHWnd($hPane) ? _SendMessage($hPane, $SCI_GETCHARAT, $_iPosition) : False))
EndFunc  ;==>_SciTE_GetCharAt

; Function Name....: _SciTE_GetLine
; Description......: Gibt den Text in der angegebenen Zeile in der angegebenen Pane zurück
; Parameter(s).....: $_iLineNumber        - a integer value.
;                    $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: Länge des Textes
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetLine($_iLineNumber, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	If Not IsHWnd($hPane) Then Return SetError(1, 0, False)

	Local $iLineLength = _SciTE_GetLineLength($_iLineNumber)
	If Not IsInt($iLineLength) Then Return SetError(1, 1, False)

	;~ $SCI_GETLINE(int line, char *text) → int
	Local $iError, $tBuffer, $hProcess, $pMem, $iRead ; , $iTextLen
	$tBuffer = DllStructCreate('char Text['&$iLineLength + 1&']')
	$hProcess = _WinAPI_OpenProcess($PROCESS_ALL_ACCESS, True, WinGetProcess($hPane), False)
	If Not @error Then
		$pMem = _MemVirtualAllocEx($hProcess, 0, $iLineLength, $MEM_COMMIT + $MEM_RESERVE, $PAGE_READWRITE)
		If Not @error Then
;~ 			$iTextLen = _SendMessage($hPane, $SCI_GETLINE, $_iLineNumber, $pMem, 0, 'int', 'ptr', 'int')
			_SendMessage($hPane, $SCI_GETLINE, $_iLineNumber, $pMem, 0, 'int', 'ptr', 'int')
			If Not @error Then
;~ 				_CW("$iTextLen                  --> " & $iTextLen)
				_WinAPI_ReadProcessMemory($hProcess, $pMem, DllStructGetPtr($tBuffer), $iLineLength, $iRead)
			EndIf
		EndIf
	EndIf
	$iError = @error
	If $pMem Then _MemVirtualFreeEx($hProcess, $pMem, $iLineLength, $MEM_RELEASE + $MEM_DECOMMIT)
	If $hProcess Then _WinAPI_CloseHandle($hProcess)

	If $iError Then Return SetError(4, 2, False)

	Return SetError($iRead ? 0 : 1, $iRead ? $iRead : 3, $iRead ? DllStructGetData($tBuffer, 'Text') : False)
EndFunc  ;==>_SciTE_GetLine

#cs (Crash!!!)
typedef struct _textrange {
  CHARRANGE chrg;
  LPSTR     lpstrText;
} TEXTRANGE;

typedef struct _charrange {
  LONG cpMin;
  LONG cpMax;
} CHARRANGE;
#ce
Func _SciTE_GetStyledText($_iLineNumber, $_iCol = -1, $_iLen = -1, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	Local Static $tagTEXTRANGE = 'struct;struct;LONG cpMin; LONG cpMax;endstruct;LONG_PTR lpstrText;endstruct'

	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	If Not IsHWnd($_hScITE) Then Return SetError(1, 0, False)
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	If Not IsHWnd($hPane) Then Return SetError(1, 1, False)

;~ 	SCI_GETSTYLEDTEXT(<unused>, Sci_TextRange *tr) → int
	Local $iError, $iLineLength, $iPosition, $iLong, $tTEXTRANGE, $tBuffer, $iBufferLen, $iStructLen, $hProcess, $pMem, $vStyledText
	; _SciTE_GetLineLength($_iLineNumber, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	$iLineLength = _SciTE_GetLineLength($_iLineNumber, $_hScITE, $_iPane)
	If Not IsInt($iLineLength) Then Return SetError(1, 2, False)
	; _SciTE_GetPositionFromLine($_iLineNumber, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	$iPosition = _SciTE_GetPositionFromLine($_iLineNumber, $_hScITE, $_iPane)
	If $_iCol < 0 Then $_iCol = 0
	If $_iLen < 1 Then $_iLen = $iLineLength - $_iCol
	If $_iLen > $iLineLength - $_iCol Then $_iLen = $iLineLength - $_iCol
	$iBufferLen = $_iLen * 2 + 2
	$iLong = (@AutoItX64 ? 3 * 8 : 3 * 4)
	$iStructLen = $iBufferLen + $iLong
	$iStructLen += Mod($iStructLen, $iLong)

	_CW("$_iLineNumber                 --> " & $_iLineNumber)
	_CW("$_iCol                        --> " & $_iCol)
	_CW("$_iLen                        --> " & $_iLen)
	_CW("$iBufferLen                --> " & $iBufferLen)
	_CW("$iStructLen                   --> " & $iStructLen)

	$hProcess = _WinAPI_OpenProcess($PROCESS_ALL_ACCESS, True, WinGetProcess($hPane), False)
	If Not @error Then
		_CW("$hProcess                     --> " & $hProcess)
		$pMem = _MemVirtualAllocEx($hProcess, 0, $iStructLen, $MEM_COMMIT + $MEM_RESERVE, $PAGE_READWRITE)
		If Not @error Then
			_CW("$pMem                         --> " & $pMem)
			$tBuffer = DllStructCreate('char StyledText['&$iBufferLen&']', $pMem + $iStructLen)
			_CW('DllStructGetSize($tBuffer)    --> ' & DllStructGetSize($tBuffer))
			$tTEXTRANGE = DllStructCreate($tagTEXTRANGE, $pMem)
			_CW('DllStructGetSize($tTEXTRANGE) --> ' & DllStructGetSize($tTEXTRANGE))
			If IsDllStruct($tTEXTRANGE) Then
				DllStructSetData($tTEXTRANGE, 'cpMin', $iPosition + $_iCol)
				DllStructSetData($tTEXTRANGE, 'cpMax', $iPosition + $_iCol + $_iLen)
				DllStructSetData($tTEXTRANGE, 'lpstrText', DllStructGetPtr($tBuffer, 'StyledText'))
				_WinAPI_DisplayStruct($tTEXTRANGE, $tagTEXTRANGE, '$tTEXTRANGE')

				ConsoleWrite('SendMessage' & @CRLF)
;~ 				_SendMessage ( $hWnd, $iMsg [, $wParam = 0 [, $lParam = 0 [, $iReturn = 0 [, $wParamType = "wparam" [, $lParamType = "lparam" [, $sReturnType = "lresult"]]]]]] )
				Local $iSend = _SendMessage($hPane, $SCI_GETSTYLEDTEXT, 0, DllStructGetPtr($tTEXTRANGE), 0, 'int', 'STRUCT', 'int')
				_CW("$iSend                     --> " & $iSend)
			EndIf
		EndIf
	EndIf
	$iError = @error
	ConsoleWrite("@@ Debug line" & @TAB & @ScriptLineNumber & "   var: $iError --> " & $iError & @CRLF & "!@ " & @TAB & "#Error: " & @error & @TAB & "#Extended: " & @extended & @CRLF)

	If Not $iError Then
		$vStyledText = DllStructGetData($tBuffer, 'StyledText')
		ConsoleWrite('$vStyledText = ' & VarGetType($vStyledText) & @CRLF)
		ConsoleWrite('$vStyledText = ' & $vStyledText & @CRLF)
	Else
		Switch False
			Case $hProcess
				Return SetError(1, 3, False)
			Case $pMem
				_WinAPI_CloseHandle($hProcess)
				Return SetError(1, 4, False)
			Case IsDllStruct($tTEXTRANGE)
				_WinAPI_CloseHandle($hProcess)
				_MemVirtualFreeEx($hProcess, $pMem, $iBufferLen, $MEM_RELEASE + $MEM_DECOMMIT)
				Return SetError(1, 5, False)
		EndSwitch
	EndIf

	Return $vStyledText
EndFunc  ;==>_SciTE_GetStyledText

;==================================================================================================
; Function Name....: _SciTE_GetLineFromPosition
; Description......: Gibt die Zeilennummer der aktuellen Position in der angegebenen Pane zurück
; Parameter(s).....: $_iPosition          - a integer value. Position (0 based)
;                    $_iPane              - [optional] a integer value. Default is 0
;                    $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: Success: Zeilennummer
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetLineFromPosition($_iPosition, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	Return SetError((IsHWnd($hPane) ? 0 : 1), 0, (IsHWnd($hPane) ? _SendMessage($hPane, $SCI_LINEFROMPOSITION, $_iPosition) : False))
EndFunc  ;==>_SciTE_GetLineFromPosition

;==================================================================================================
; Function Name....: _SciTE_GetPositionFromLine
; Description......: Gibt die Startposition der Zeilennummer zurück
; Parameter(s).....: $_iLineNumber        - a integer value. LineNumber 0 based
;                    $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: Zeilennummer
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetPositionFromLine($_iLineNumber, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	Return SetError((IsHWnd($hPane) ? 0 : 1), 0, (IsHWnd($hPane) ? _SendMessage($hPane, $SCI_POSITIONFROMLINE, $_iLineNumber) : False))
EndFunc  ;==>_SciTE_GetPositionFromLine

;==================================================================================================
; Function Name....: _SciTE_GetStyleAt
; Description......: Gibt die Startposition der Zeilennummer zurück
; Parameter(s).....: $_iPosition          - a integer value. Position 0 based
;                    $_hScITE             - [optional] a handle value. Default is ''
;                    $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: Success: Style (Int)
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetStyleAt($_iPosition, $_hScITE = '', $_iPane = $eSCI_EditorPane)
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hPane = $_iPane = $eSCI_EditorPane ? _SciTE_GetHWndFromEditor($_hScITE) : _SciTE_GetHWndFromOutput($_hScITE)
	Return SetError((IsHWnd($hPane) ? 0 : 1), 0, (IsHWnd($hPane) ? _SendMessage($hPane, $SCI_GETSTYLEAT, $_iPosition) : False))
EndFunc  ;==>_SciTE_GetStyleAt

;==================================================================================================
; Function Name....: _SciTE_GetCurrentFileName
; Description......: Gibt den Pfad der aktuell im Editor geöffneten Datei zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: Dateipfad
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetCurrentFileName($_hScITE = '')
	_SciTE_SendCommand("askfilename:", 1, $_hScITE)
	If @error Then Return SetError(1, 0, False)

	Local $sCurrentFile = $g_SciTECmd
	$g_SciTECmd = ''
	Return StringRegExpReplace(StringTrimLeft(_WideCharToMultiByte($sCurrentFile), StringInStr($sCurrentFile, ':', 1, 1)), '[\\]+', '\\')
EndFunc  ;==>_SciTE_GetCurrentFileName

;==================================================================================================
; Function Name....: _SciTE_GetCurrentFile
; Description......: Gibt den Quellcode der aktuell im Editor geöffneten Datei zurück
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: CurrentFile
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetCurrentFile($_hScITE = '')
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local $hEditor = _SciTE_GetHWndFromEditor($_hScITE)
	Return SetError((IsHWnd($hEditor) ? 0 : 1), 0, (IsHWnd($hEditor) ? ControlGetText($hEditor, '', '') : False))
EndFunc  ;==>_SciTE_GetCurrentFile

;==================================================================================================
; Function Name....: _SciTE_GetProperty
; Description......: Gibt den Wert für eine Property zurück
; Parameter(s).....: $_sProperty          - a string value. Property
;                    $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: Wert der Property
;                    Failure: Set @error and False
; Docu.............: http://www.scintilla.org/SciTEDoc.html od. "SciTE-Hilfe" --> "SciTE Documentation"
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetProperty($_sProperty, $_hScITE = '')
	_SciTE_SendCommand("askproperty:" & $_sProperty, 1, $_hScITE)
	If @error Then Return SetError(1, 0, False)

	Return $g_SciTECmd = '' ? '' : _WideCharToMultiByte(StringTrimLeft($g_SciTECmd, StringInStr($g_SciTECmd, ':', 1, 4)))
EndFunc  ;==>_SciTE_GetProperty

;==================================================================================================
; Function Name....: _SciTE_CloseCurrentFile
; Description......: Schließt die aktuell offene Datei im Editor
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_CloseCurrentFile($_hScITE = '')
	_SciTE_SendCommand("close:", $eSCI_NoWait, $_hScITE)
	Return SetError(@error, 0, @error ? False : True)
EndFunc  ;==>_SciTE_CloseCurrentFile

;==================================================================================================
; Function Name....: _SciTE_FindString
; Description......: Sucht nach einem übergebenen String und selektiert ihn, wenn
; .................: gefunden (erstes Vorkommen)
; Parameter(s).....: $_sString            - a string value. Suchstring
;                    $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_FindString($_sString, $_hScITE = '')
	If $_sString = '' Then Return SetError(1, 0, False)
	Local $iCurrentPosition = _SciTE_GetCurrentPosition()
	_SciTE_SendCommand("find:" & _WideCharToMultiByte($_sString), $eSCI_NoWait, $_hScITE)
	If @error Then Return SetError(@error, 1, False)
	Local $iNewCurrentPosition = _SciTE_GetCurrentPosition()
	Return $iNewCurrentPosition = $iCurrentPosition ? False : $iNewCurrentPosition - StringLen($_sString)
EndFunc  ;==>_SciTE_FindString

;==================================================================================================
; Function Name....: _SciTE_GoToLineCol
; Description......: Setzt den Cursor auf die übergebene Zeilen und (optional)
; .................: Spaltenposition. Zeile: 1-basiert, Spalte: 0-basiert
; .................: Ist an dieser Position ein Wort, wird es selektiert
; Parameter(s).....: $_iLine              - an integer value. Default is -1. Zeile
;                    $_iCol               - [optional] an integer value. Default is -1. Spalte
;                    $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GoToLineCol($_iLine, $_iCol = -1, $_hScITE = '')
	_SciTE_SendCommand("goto:" & $_iLine & ($_iCol > -1 ? "," & $_iCol : ""), $eSCI_NoWait, $_hScITE)
	Return SetError(@error, 0, @error ? False : True)
EndFunc  ;==>_SciTE_GoToLineCol

;==================================================================================================
; Function Name....: _SciTE_InsertValue
; Description......: Fügt an aktueller Cursorposition od. Selektion den übergebenen
;                    Wert ein
; Parameter(s).....: $_vValue             - a string value. Einfügestring
;                    $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_InsertValue($_vValue, $_hScITE = '')
	_SciTE_SendCommand("insert:" & _WideCharToMultiByte($_vValue), $eSCI_NoWait, $_hScITE)
	Return SetError(@error, 0, @error ? False : True)
EndFunc  ;==>_SciTE_InsertValue

;==================================================================================================
; Function Name....: _SciTE_MenuCmd
; Description......: Führt einen Menübefehl aus
; Parameter(s).....: $_CmdID              - a string value. Command-ID
;                    $_hScITE             - [optional] a handle value. Default is ''
; Requirement(s)...: SciTE_Constants.au3
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Docu.............: http://www.scintilla.org/CommandValues.html
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_MenuCmd($_CmdID, $_hScITE = '')
	_SciTE_SendCommand("menucommand:" & $_CmdID, $eSCI_NoWait, $_hScITE)
	Return SetError(@error, 0, @error ? False : True)
EndFunc  ;==>_SciTE_MenuCmd

;==================================================================================================
; Function Name....: _SciTE_FileOpen
; Description......: Öffnet eine Datei im Editor
; Parameter(s).....: $_sPath              - a string value. Dateipfad
;                    $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_FileOpen($_sPath, $_hScITE = '')
	_SciTE_SendCommand("open:" & StringRegExpReplace(_WideCharToMultiByte($_sPath), '[\\]+', '\\\\'), $eSCI_NoWait, $_hScITE)
	Return SetError(@error, 0, @error ? False : True)
EndFunc  ;==>_SciTE_FileOpen

;==================================================================================================
; Function Name....: _SciTE_OutputToConsole
; Description......: Gibt einen Wert in die Konsole aus
; Parameter(s).....: $_vValue             - a string value. auszugebender Wert
;                                           (Zeilenumbruch mit "\n", Tab mit "\t")
;                    $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_OutputToConsole($_vValue, $_hScITE = '')
	_SciTE_SendCommand("output:" & _WinAPI_WideCharToMultiByte(String($_vValue), 65001), $eSCI_NoWait, $_hScITE)
	Return SetError(@error, 0, @error ? False : True)
EndFunc  ;==>_SciTE_OutputToConsole

;==================================================================================================
; Function Name....: _SciTE_SetProperty
; Description......: Setzt den Wert einer Property
; Parameter(s).....: $_sProperty          - a string value. Property
;                    $_sValue             - a string value. Wert
;                    $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_SetProperty($_sProperty, $_sValue, $_hScITE = '')
	_SciTE_SendCommand("property:" & $_sProperty & "=" & _WideCharToMultiByte($_sValue), $eSCI_NoWait, $_hScITE)
	Return SetError(@error, 0, @error ? False : True)
EndFunc  ;==>_SciTE_SetProperty

;==================================================================================================
; Function Name....: _SciTE_ReloadProperties
; Description......: Lädt die Properties neu
; Parameter(s).....: $_hScITE              - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_ReloadProperties($_hScITE = '')
	_SciTE_SendCommand("reloadproperties:", $eSCI_NoWait, $_hScITE)
	Return SetError(@error, 0, @error ? False : True)
EndFunc  ;==>_SciTE_ReloadProperties

;==================================================================================================
; Function Name....: _SciTE_ReplaceAll
; Description......: Ersetzt alle Vorkommen eines Suchbegriffs
; Parameter(s).....: $_sSearch            - a string value. Suchwort
;                    $_sReplace           - a string value. Ersetzung
;                    $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_ReplaceAll($_sSearch, $_sReplace, $_hScITE = '')
	_SciTE_SendCommand(_WideCharToMultiByte("replaceall:" & $_sSearch & "\000" & $_sReplace), $eSCI_NoWait, $_hScITE)
	Return SetError(@error, 0, @error ? False : True)
EndFunc  ;==>_SciTE_ReplaceAll

;==================================================================================================
; Function Name....: _SciTE_FileSaveAs
; Description......: Datei unter angegebenem Pfad speichern
; Parameter(s).....: $_sPath              - a string value. Dateipfad
;                    $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_FileSaveAs($_sPath, $_hScITE = '')
	_SciTE_SendCommand("saveas:" & StringRegExpReplace(_WideCharToMultiByte($_sPath), '[\\]+', '\\\\'), $eSCI_NoWait, $_hScITE)
	Return SetError(@error, 0, @error ? False : True)
EndFunc  ;==>_SciTE_FileSaveAs

;==================================================================================================
; Function Name....: _SciTE_GetCodepage
; Description......: Get Codepage from SciTE
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
; Parameter(s).....: $_iPane              - [optional] a integer value. Default is 0
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetCodepage($_hScITE = '', $_iPane = $eSCI_EditorPane)
	Local $sAsk, $iCodepage
	Switch $_iPane
		Case $eSCI_EditorPane
			$sAsk = 'code.page'
		Case $eSCI_OutputPane
			$sAsk = 'output.code.page'
		Case Else
			Return SetError(1, 0, False)
	EndSwitch
	$iCodepage = _SciTE_SendCommand("askproperty:" & $sAsk, $eSCI_Wait, $_hScITE) ; SciTE output pane
	Return SetError(@error, 0, @error ? False : $iCodepage)

;~ 	$SB_Convert = $g_iSCI_OutputCodepage = 65001 ? $SB_UTF8 : $SB_ANSI
EndFunc  ;==>_SciTE_GetCodepage

;==================================================================================================
; Function Name....: _SciTE_GetHwndDirectorExtension
; Description......: Get Hwnd from DirectorExtension
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: BugFix ( bugfix@autoit.de )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_GetHwndDirectorExtension($_hScITE = '')
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	If IsHWnd($_hScITE) Then
		Local $PIDActive = WinGetProcess($_hScITE), $aExtension = WinList("DirectorExtension"), $PIDExt
		For $i = 1 To $aExtension[0][0]
			$PIDExt = WinGetProcess($aExtension[$i][1])
			If $PIDExt = $PIDActive Then Return $aExtension[$i][1]
		Next
	EndIf
	Return SetError(1, 0, False)
EndFunc  ;==>_SciTE_GetHwndDirectorExtension

; by Jos
;==================================================================================================
; Function Name....: _SciTE_SendCommand
; Description......: Send command to SciTE
; Parameter(s).....: $_hScITE             - [optional] a handle value. Default is ''
; Return Value(s)..: keine
;                    Failure: Set @error and False
; Author(s)........: Jos ( Jos@www.autoitscript.com )
; Modified.........: Bitnugger ( bitnugger@autoit.de )
;==================================================================================================
Func _SciTE_SendCommand($_sCmd, $Wait_For_Return_Info = $eSCI_NoWait, $_hScITE = '')
	$_hScITE = _SciTE_GetHWndFromSciTE($_hScITE) ; If $_hScITE not a handle then determine the last active SciTeWindow.
	Local Static $hMyWnd
	If Not IsHWnd($hMyWnd) Then
		Local $hPrevGUI = GUISwitch(WinGetHandle('[ACTIVE]'))
		$hMyWnd = GUICreate("AutoIt3-SciTE Interface") ; Create GUI to receive SciTE info
		GUISwitch($hPrevGUI)
	EndIf

	Local Static $My_Dec_Hwnd = Dec(StringTrimLeft($hMyWnd, 2)) ; Convert my Gui Handle to decimal
	Local $hScITEWnd = _SciTE_GetHwndDirectorExtension($_hScITE) ; Get SciTE DIrector Handle
	If @error Then Return SetError(1, 0, False)

	$_sCmd = ":" & $My_Dec_Hwnd & ":" & $_sCmd ; Add dec my gui handle to commandline to tell SciTE where to send the return info
	Local $CmdStruct = DllStructCreate('CHAR[' & StringLen($_sCmd) + 1 & ']')
	DllStructSetData($CmdStruct, 1, $_sCmd)
	Local $COPYDATA = DllStructCreate('ULONG_PTR;DWORD;PTR')
	DllStructSetData($COPYDATA, 1, 1)
	DllStructSetData($COPYDATA, 2, StringLen($_sCmd) + 1)
	DllStructSetData($COPYDATA, 3, DllStructGetPtr($CmdStruct))
	$g_SciTECmd = ""
	DllCall('User32.dll', 'None', 'SendMessage', _
			'HWnd', $hScITEWnd, _
			'Int', $WM_COPYDATA, _
			'HWnd', $hMyWnd, _
			'Ptr', DllStructGetPtr($COPYDATA))
;~ 	GUIDelete($hMyWnd)
	If $Wait_For_Return_Info Then
		For $x = 1 To 10
			If $g_SciTECmd <> "" Then ExitLoop
			Sleep(20)
		Next
		$g_SciTECmd = StringTrimLeft($g_SciTECmd, StringLen(":" & $My_Dec_Hwnd & ":"))
		$g_SciTECmd = StringReplace($g_SciTECmd, "macro:stringinfo:", "")
		Return $g_SciTECmd
	EndIf
EndFunc  ;==>_SciTE_SendCommand

;~ https://docs.microsoft.com/en-us/windows/desktop/api/Winuser/ns-winuser-tagcopydatastruct
;~ typedef struct tagCOPYDATASTRUCT {
;~   ULONG_PTR dwData; --> ULONG_PTR
;~   DWORD     cbData; --> DWORD
;~   PVOID     lpData; --> PTR
;~ } COPYDATASTRUCT, *PCOPYDATASTRUCT;
Func _WM_COPYDATA($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg, $wParam
;~ 	If $SciTE_Interface_Debug Then ConsoleWrite('@@ (323) :(' & @MIN & ':' & @SEC & ') _WM_COPYDATA()' & @LF) ;### Function Trace
	Local $COPYDATA = DllStructCreate('ULONG_PTR;DWORD;PTR', $lParam)
	Local $SciTECmdLen = DllStructGetData($COPYDATA, 2)
	Local $CmdStruct = DllStructCreate('CHAR['&$SciTECmdLen&']', DllStructGetData($COPYDATA, 3))
	$g_SciTECmd = StringLeft(DllStructGetData($CmdStruct, 1), $SciTECmdLen)
EndFunc  ;==>_WM_COPYDATA
