﻿;-- TIME_STAMP   2019-05-15 01:33:24   v 1.1

#Region **** Directives created by AutoIt3Wrapper_GUI ****
;~ #AutoIt3Wrapper_AU3Check_Parameters=-q -d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w- 7
#EndRegion **** Directives created by AutoIt3Wrapper_GUI ****

#Region    ;************ Includes ************
#include-once
#include <Array.au3>
#include <BlockInputEx.au3>
#include <Debug.au3>
#include <GuiRichEdit.au3>
#include <GuiToolbar.au3>
#include <Misc.au3>
#include <Process.au3>
#include <WinAPIGdi.au3>
#include <_SciTE_Interface.au3>
#EndRegion ;************ Includes ************

#NoTrayIcon
;~ Opt('TrayIconHide', 1)

;~ _SciTE_GetColorFromText : 6325.9808 ms
;~ _RichEdit_SetColoredText: 6735.879 ms
;~ _SciTE_ShowFuncName     : 13455.3885 ms
;~ ConsoleWrite(13455.3885 - 6325.9808 - 6735.879 & @CRLF)
;~ Exit

If Not @Compiled Then
	If ProcessExists('_SciTE_ShowFuncName (RichEdit).exe') Then
		ProcessClose('_SciTE_ShowFuncName (RichEdit).exe')
		Exit
	Else
;~ 		_SetHotKey('^!{F1}', '_F1') ; Ctrl+Alt+F1 ; Kann zwar gesetzt werden, funktioniert aber nicht, weil MouseWithoutBorders den trotzdem abfängt!!! ???
		_SetHotKey('^+{F1}', '_F1') ; Ctrl+Shift+F1 - Dump
		_SetHotKey('^!x', '_Exit')  ; Ctrl+Alt+X    - Exit
	EndIf
EndIf

_Singleton('_SciTE_ShowFuncName') ; Enforce a design paradigm where only one instance of the script may be running

Global Const $ENM_NONE = 0 ; https://www.autoitscript.com/trac/autoit/ticket/3713#ticket
Global Enum $ehScITE, $ehToolBar, $eaPosToolBar, $ehRichEdit, $ehSource, $esFuncName, $esOldFuncName, $esSizeOff
Global $g_aSciTE[0][$esSizeOff], $g_aColorText, $g_hActive, $g_sClassName, $g_sFocus, $g_sProcessName, $g_hFocus

#cs _SciTE_GetStyledText - ich denke, damit würde es viel schneller gehen, als mit _SciTE_GetStyleAt, aber das funktoniert leider noch nicht (Crash)!!!
;~ 	Eine Alternative für RichEdit wäre, es mit Scintilla (sciteit) zu machen.

_SciTE_GetStyledText($_iLineNumber, $_iCol = -1, $_iLen = -1, $_hScITE = '', $_iPane = $eSCI_EditorPane)
 _SciTE_GetStyledText(0) ; AutoIt3.exe ended.rc:-1073741819
 Exit
#ce

;~ Sleep(3000)
;~ Global $g_hTimer = TimerInit()
While 1
	$g_hActive = WinWaitActive('[CLASS:SciTEWindow]')
	$g_sFocus = ControlGetFocus($g_hActive, '')
	If $g_sFocus = 'Scintilla1' Then _SciTE_ShowFuncName()
;~ 	ConsoleWrite('_SciTE_ShowFuncName     : ' & TimerDiff($g_hTimer) & ' ms' & @CRLF)
;~ 	Exit
	Sleep(750) ; 250
WEnd

Func _SciTE_ShowFuncName()
	$g_hFocus = ControlGetHandle($g_hActive, '', '[CLASSNN:' & $g_sFocus & ']')

	_UpdateWinList($g_hActive)

	Local $bChange = False, $iSciTE, $iIndex, $aColorText[1][3], $aMaxSize, $aPosToolBar, $aOldPosToolBar, $sCurrentFileName, $aSource, $sSource, $sEOLMode, $iMixedEOLMode, $sEOLModePattern, $iCurrentPos, $iCurrentLineNumber, $aFuncs, $vRX

	$iSciTE = _ArraySearch($g_aSciTE, $g_hActive)
	If Not BitAND(WinGetState($g_aSciTE[$iSciTE][$ehScITE]), $WIN_STATE_VISIBLE) Or BitAND(WinGetState($g_aSciTE[$iSciTE][$ehScITE]), $WIN_STATE_MINIMIZED) Then Return
;~ 	ConsoleWrite('----------------------------------------------------------------------------------------------' & @CRLF)
	$sCurrentFileName = _SciTE_GetCurrentFileName($g_aSciTE[$iSciTE][$ehScITE])
;~ 	_CW("$sCurrentFileName          --> " & $sCurrentFileName)
	If StringRight($sCurrentFileName, 3) <> 'au3' Then Return

	$aPosToolBar = ControlGetPos($g_aSciTE[$iSciTE][$ehToolBar], '', '')
	If @error Then Return
	$aOldPosToolBar = $g_aSciTE[$iSciTE][$eaPosToolBar]
	If $aPosToolBar[2] <> $aOldPosToolBar[2] Then
		$g_aSciTE[$iSciTE][$eaPosToolBar] = $aPosToolBar
		$aMaxSize = _GUICtrlToolbar_GetMaxSize($g_aSciTE[$iSciTE][$ehToolBar])
		ControlMove($g_aSciTE[$iSciTE][$ehRichEdit], '', '', $aMaxSize[0] + 5, $aPosToolBar[1], $aPosToolBar[2] - $aMaxSize[0] - 8, $aPosToolBar[3] - 2)
	EndIf

	$sSource = ControlGetText($g_aSciTE[$iSciTE][$ehSource], '', '')
	$sEOLMode = _GetEOLMode($sSource, $g_aSciTE[$iSciTE][$ehScITE])
	$iMixedEOLMode = @extended

	Switch $sEOLMode
		Case False
			Exit @ScriptLineNumber
		Case @CRLF, @LF, @CR
			$sEOLModePattern = $iMixedEOLMode ? '\r\n|\r|\n|.+\r\n|.+\r|.+\n|.+' : $sEOLMode&'|.+' & $sEOLMode & '|.+'
			$aSource = StringRegExp($sSource, $sEOLModePattern, $STR_REGEXPARRAYGLOBALMATCH)
;~ 			$aSource = StringRegExp($sSource, $sEOLMode&'|.+' & $sEOLMode & '|.+', $STR_REGEXPARRAYGLOBALMATCH)
;~ 			$aSource = StringRegExp($sSource, '\r\n|\r|\n|.+\r\n|.+\r|.+\n|.+', $STR_REGEXPARRAYGLOBALMATCH)
;~ 			_CW("! $sCurrentFileName          --> " & $sCurrentFileName)
;~ 			_CW("! $sEOLMode                  --> " & Binary($sEOLMode))
;~ 			_DebugArrayDisplay($aSource, '$aSource')
			If UBound($aSource) Then
				If StringRight($aSource[UBound($aSource) -1], StringLen($sEOLMode)) = $sEOLMode Then _ArrayAdd($aSource, '')
				$iCurrentPos = _SciTE_GetCurrentPosition($g_aSciTE[$iSciTE][$ehScITE], $eSCI_EditorPane)
;~ 				_CW("$iCurrentPos               --> " & $iCurrentPos)
				$iCurrentLineNumber = _SciTE_GetLineFromPosition($iCurrentPos, $g_aSciTE[$iSciTE][$ehScITE], $eSCI_EditorPane)
;~ 				_CW("$hSource                   --> " & $hSource)
;~ 				_CW("! $iCurrentLineNumber      --> " & $iCurrentLineNumber)
;~ 				Exit

				$aFuncs = _ArrayFindAll($aSource, '^(Func|EndFunc)', 0, 0, 0, 3)
				$g_aSciTE[$iSciTE][$esFuncName] = ''
				If UBound($aFuncs) -1 > 0 Then
;~ 					_DebugArrayDisplay($aFuncs, '$aFuncs')
					For $j = 0 To UBound($aFuncs) -1 Step 2
						Switch True
							Case $aFuncs[$j] <= $iCurrentLineNumber And $j + 1 <= UBound($aFuncs) -1 And $aFuncs[$j + 1] >= $iCurrentLineNumber
								If StringLeft($aSource[$aFuncs[$j]], 4) = 'Func' And StringLeft($aSource[$aFuncs[$j + 1]], 7) = 'EndFunc' Then
;~ 									_CW("> $aSource[$aFuncs[$j]]      --> " & $aSource[$aFuncs[$j]])
;~ 									_CW("$aSource[$aFuncs[$j +1]] --> " & $aSource[$aFuncs[$j +1]])

									; StringRegExpReplace
;~ 									$vRX = StringRegExpReplace($aSource[$aFuncs[$j]], '^Func\s(\w+).*', '\1') ; ohne Parameter
									$vRX = StringRegExpReplace($aSource[$aFuncs[$j]], '^Func\h*(\w+\h*(\((((''|")((((?!\5).)*)|(?4))*\5)|([^()]*)|(?2))*\)))\h*(;.*)?\h*\R*$', '\1') ; mit Parameter
									$g_aSciTE[$iSciTE][$esFuncName] = @extended ? $vRX : 'RegEx-Error!'

									; StringRegExp
;~ 									$vRX = StringRegExp($aSource[$aFuncs[$j]], '(?U)Func\s(.+)\(.*', $STR_REGEXPARRAYMATCH) ; ohne Parameter
;~ 									$vRX = StringRegExp($aSource[$iSciTE][1], '^Func\s(.+\))\s+?;.*?\R?$', $STR_REGEXPARRAYMATCH) ; mit Parameter
;~ 									$g_aSciTE[$iSciTE][$esFuncName] = @error ? 'RegEx-Error!' : $vRX[0]
									ExitLoop
								EndIf
						EndSwitch
					Next
				EndIf
			Else
				$g_aSciTE[$iSciTE][$esFuncName] = ''
			EndIf
	EndSwitch

;~ 	_CW("FuncName                   --> " & StringStripWS($g_aSciTE[$iSciTE][$esFuncName], $STR_STRIPTRAILING))
	If $g_aSciTE[$iSciTE][$esOldFuncName] <> $g_aSciTE[$iSciTE][$esFuncName] Then
		$g_aSciTE[$iSciTE][$esOldFuncName] = $g_aSciTE[$iSciTE][$esFuncName]
		$bChange = True
		If $g_aSciTE[$iSciTE][$esFuncName] Then
			$aColorText = _SciTE_GetColorFromText($g_aSciTE[$iSciTE][$ehScITE], $aFuncs[$j], 5, $g_aSciTE[$iSciTE][$esFuncName])
			If $iMixedEOLMode Then
				$iIndex = _ArrayAdd($aColorText, ' (Mixed EOLMode!)')
				$aColorText[$iIndex][1] = '+bo'
				$aColorText[$iIndex][2] = _ColorConvert(0xFF0000)
			EndIf
			_RichEdit_SetColoredText($g_aSciTE[$iSciTE][$ehRichEdit], $aColorText)
		Else
			_GUICtrlRichEdit_SetText($g_aSciTE[$iSciTE][$ehRichEdit], '') ; Text löschen
		EndIf
	EndIf
;~ 	ConsoleWrite('----------------------------------------------------------------------------------------------' & @CRLF & @CRLF)
EndFunc   ;==>_SciTE_ShowFuncName

Func _SciTE_GetColorFromText($hSciTE, $iLine, $iCol, $sText)
;~ 	Local $hTimer = TimerInit()
;~ 	_CWSF('\n> $hSciTE: %s, $iLine: %5i, $iCol: %5i, $sText: %s', $hSciTE, $iLine, $iCol, $sText)
	Local $iPositionFromLine = _SciTE_GetPositionFromLine($iLine, $hSciTE, $eSCI_EditorPane)

	Local $iTextPosition = $iPositionFromLine + $iCol, $aColorText[0][3], $iIndex = 0, $iStyle, $sColor, $iColor ;, $sChar
;~ 	_CWSF("\n> %-10s %-7s %-38s %-8s %-3s \t %-3s", '$iPosition', '$iStyle', '$sColor', '$iColor', 'Chr', 'Asc')

	For $iPosition = $iTextPosition To $iTextPosition + StringLen($sText) -1 Step 1
		$iStyle = _SciTE_GetStyleAt($iPosition, $hScITE, $eSCI_EditorPane)
		If Not UBound($aColorText) Or $aColorText[$iIndex -1][1] <> $iStyle Then
			$iIndex += 1
			ReDim $aColorText[$iIndex][3]
			$aColorText[$iIndex -1][0] &= StringMid($sText, $iPosition - $iTextPosition + 1, 1)
;~ 			$aColorText[$iIndex -1][1] = $iStyle
			$sColor = _SciTE_GetProperty('style.au3.' & $iStyle, $hScITE)
			$aColorText[$iIndex -1][1] &= StringInStr($sColor, 'italics') ? '+it' : ''
			$aColorText[$iIndex -1][1] &= StringInStr($sColor, 'bold') ? '+bo' : ''
			$iColor = $sColor ? StringRegExpReplace($sColor, '(?i)fore:#([0-9a-f]+).*', '0x\1') : 0x000000
			$aColorText[$iIndex -1][2] = _ColorConvert($iColor)
		Else
			$aColorText[$iIndex -1][0] &= StringMid($sText, $iPosition - $iTextPosition + 1, 1)
		EndIf
;~ 		$sChar = StringMid($sText, $iPosition - $iTextPosition + 1, 1)
;~ 		$sChar = ChrW(_SciTE_GetCharAt($iPosition, $hSciTE))
;~ 		_CWSF("- %10i %7i %-38s 0x%s %-4s %s %3i", $iPosition, $iStyle, $sColor, Hex($aColorText[$iIndex -1][2], 6), '"'&$sChar&'"' & ($sChar = @TAB ? '' : @TAB), ($sChar = @TAB ? @TAB & ' ' : ''), Asc($sChar))
;~ 		Sleep(250)
	Next
;~ 	ConsoleWrite('_SciTE_GetColorFromText : ' & TimerDiff($hTimer) & ' ms' & @CRLF)

	Return $aColorText
EndFunc   ;==>_SciTE_GetColorFromText

Func _RichEdit_SetColoredText($hRichEdit, $aColorText)
;~ 	Local $hTimer = TimerInit()
	$g_aColorText = $aColorText
	Local $iStart = 0, $iEnd
	_BlockInputEx(3) ; Tastatur sperren
	_WinAPI_LockWindowUpdate($hRichEdit)
	_GUICtrlRichEdit_SetText($hRichEdit, '') ; Text löschen
	$aColorText[0][0] = ' ' & $aColorText[0][0]
	For $i = 0 To UBound($aColorText) -1 Step 1
		_GUICtrlRichEdit_AppendText($hRichEdit, $aColorText[$i][0]) ; Text anhängen
		$iEnd = $iStart + StringLen($aColorText[$i][0])
		_GUICtrlRichEdit_SetSel($hRichEdit, $iStart, $iEnd) ; Eingefügten Text selektieren
		_GUICtrlRichEdit_SetCharColor($hRichEdit, $aColorText[$i][2]) ; Eingefügten Text einfärben
		If $aColorText[$i][1] Then _GUICtrlRichEdit_SetCharAttributes($hRichEdit, $aColorText[$i][1]) ; Attribute (bold, italic, ...) setzen
		$iStart += StringLen($aColorText[$i][0])
	Next
	_GUICtrlRichEdit_Deselect($hRichEdit) ; Selektierung entfernen
	_WinAPI_LockWindowUpdate(0)
	ControlFocus($g_hFocus, '', '')
	_BlockInputEx(0) ; Tastatur freigeben
;~ 	ConsoleWrite('_RichEdit_SetColoredText: ' & TimerDiff($hTimer) & ' ms' & @CRLF)
EndFunc   ;==>_RichEdit_SetColoredText

Func _UpdateWinList($hSciTEWindow)
	Local $iState, $iIndex, $bCreate = False, $aMaxSize, $aPosToolBar

	; Nicht mehr vorhandene Fenster aus der Liste entfernen
	For $i = UBound($g_aSciTE) -1 To 0 Step -1
		If Not WinExists($g_aSciTE[$i][$ehScITE]) Then
			_GUICtrlRichEdit_Destroy($g_aSciTE[$i][$ehRichEdit])
			_ArrayDelete($g_aSciTE, $i)
		EndIf
	Next

	; Neues Fenster der Liste hinzufügen
	_ArraySearch($g_aSciTE, $hSciTEWindow)
	If @error Then
		$bCreate = True
		$iIndex = UBound($g_aSciTE)
		ReDim $g_aSciTE[$iIndex + 1][$esSizeOff]
		$g_aSciTE[$iIndex][$ehScITE] = $hSciTEWindow

		$g_aSciTE[$iIndex][$ehToolBar] = ControlGetHandle($g_aSciTE[$iIndex][$ehScITE], '', '[CLASS:ToolbarWindow32; INSTANCE:1]')
		$iState = ControlCommand($g_aSciTE[$iIndex][$ehToolBar], '', '', 'IsVisible')
		If Not $iState Then _SciTE_MenuCmd($IDM_VIEWTOOLBAR, $g_aSciTE[$iIndex][$ehScITE])
		$aMaxSize = _GUICtrlToolbar_GetMaxSize($g_aSciTE[$iIndex][$ehToolBar])
		$aPosToolBar = ControlGetPos($g_aSciTE[$iIndex][$ehToolBar], '', '')
		If @error Then Exit @ScriptLineNumber

		$g_aSciTE[$iIndex][$eaPosToolBar] = $aPosToolBar

		_BlockInputEx(3) ; Tastatur sperren
		$g_aSciTE[$iIndex][$ehRichEdit] = _GUICtrlRichEdit_Create($g_aSciTE[$iIndex][$ehToolBar], '', $aMaxSize[0] + 5, $aPosToolBar[1], $aPosToolBar[2] - $aMaxSize[0] - 8, $aPosToolBar[3] - 2, BitOR($ES_LEFT, $ES_READONLY)) ; ClassName = 'RICHEDIT50W'
;~ 		Local $aColorScheme = _GUICtrlToolbar_GetColorScheme($g_aSciTE[$iIndex][$ehToolBar]) ; <-- Funktioniert nicht!
;~ 		ConsoleWrite('$aColorScheme = ' & _ArrayToString($aColorScheme, ', ') & @CRLF) ; --> 0, 0
;~ 		_GUICtrlRichEdit_SetBkColor($g_aSciTE[$iIndex][$ehRichEdit], $aColorScheme[0])
		_GUICtrlRichEdit_SetBkColor($g_aSciTE[$iIndex][$ehRichEdit], 0xF0F0F0)
		_GUICtrlRichEdit_SetEventMask($g_aSciTE[$iIndex][$ehRichEdit], $ENM_NONE) ; https://www.autoitscript.com/trac/autoit/ticket/3713#ticket
		_GUICtrlRichEdit_SetFont($g_aSciTE[$iIndex][$ehRichEdit], 11, 'Courier New') ; , $iCharSet, $iLcid)
		ControlFocus($g_hFocus, '', '')
		_BlockInputEx(0) ; Tastatur freigeben

		$g_aSciTE[$iIndex][$ehSource] = ControlGetHandle($g_aSciTE[$iIndex][$ehScITE], '', '[CLASS:Scintilla; INSTANCE:1]')
	EndIf

	Return $bCreate
;~ 	_DebugArrayDisplay($g_aSciTE, '$g_aSciTE')
EndFunc   ;==>_UpdateWinList

; 696.9709 ms
Func _GetEOLMode(ByRef $sSource, $hScITE = '')
	Local $eolauto = _SciTE_GetProperty('eol.auto', $hScITE)
	Local $eolmode = _SciTE_GetProperty('eol.mode', $hScITE)
	If @error Then Return SetError(1, 0, False)

	Local $iEOL, $iCRLF, $iLF
	Switch True
		Case $eolauto = 1, $eolmode = ''
			If $sSource Then
				StringReplace($sSource, @CRLF, '')
				$iCRLF = @extended
				StringReplace($sSource, @LF, '')
				$iLF = @extended
				$iEOL = $iCRLF >= $iLF ? @CRLF : @LF
			Else
				$iEOL = @CRLF
			EndIf
		Case Else
			$iEOL = '@' & $eolmode
	EndSwitch
	Return SetExtended(($iCRLF > 0 And $iLF > 0) And ($iCRLF <> $iLF) ? 1 : 0, $iEOL)
EndFunc  ;==>_GetEOLMode

; RGB to BGR or BGR to RGB
Func _ColorConvert($iColor)
	Return BitOR(BitAND($iColor, 0x00FF00), BitShift(BitAND($iColor, 0x0000FF), -16), BitShift(BitAND($iColor, 0xFF0000), 16))
EndFunc  ;==>_ColorConvert

; 577.2233 ms
Func _SetHotKey($sHotKey, $sFunction)
	If Not HotKeySet($sHotKey, $sFunction) Then Exit MsgBox(16, @ScriptName, 'HotKey "' & $sHotKey & '" konnte nicht gesetzt werden!')
EndFunc  ;==>_SetHotKey

Func _F1()
	_DebugArrayDisplay($g_aSciTE, '$g_aSciTE')
	_DebugArrayDisplay($g_aColorText, '$g_aColorText')
EndFunc  ;==>_F1

; 186.7692 ms
Func _Exit()
	Exit
EndFunc  ;==>_Exit

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

; Standard-Funktion - 1357.3148 ms
Func _ColorGetCOLORREF($iColor, Const $_iCurrentExtended = @extended)
	If BitAND($iColor, 0xFF000000) Then Return SetError(1, 0, 0) ; invalid color value
	Local $aColor[3]
	$aColor[2] = BitAND(BitShift($iColor, 16), 0xFF)
	$aColor[1] = BitAND(BitShift($iColor, 8), 0xFF)
	$aColor[0] = BitAND($iColor, 0xFF)
	Return SetExtended($_iCurrentExtended, $aColor)
EndFunc   ;==>_ColorGetCOLORREF

; User-Funktion - 509.1613 ms
Func _ComErrorHandler()
EndFunc  ;==>_ComErrorHandler

; 12991.7962 ms
Func _AssembleIt2($Returntype, $sFunc, $Type1 = "", $Param1 = 0, $Type2 = "", $Param2 = 0, $Type3 = "", $Param3 = 0, $Type4 = "", $Param4 = 0, $Type5 = "", $Param5 = 0, $Type6 = "", $Param6 = 0, $Type7 = "", $Param7 = 0, $Type8 = "", $Param8 = 0, $Type9 = "", $Param9 = 0, $Type10 = "", $Param10 = 0, $Type11 = "", $Param11 = 0, $Type12 = "", $Param12 = 0, $Type13 = "", $Param13 = 0, $Type14 = "", $Param14 = 0, $Type15 = "", $Param15 = 0, $Type16 = "", $Param16 = 0, $Type17 = "", $Param17 = 0, $Type18 = "", $Param18 = 0, $Type19 = "", $Param19 = 0, $Type20 = "", $Param20 = 0) ;assembles the code      if @AutoItX64 then exit(Msgbox(64,"_AssembleIt()","Sorry, not possible in 64Bit-Mode, use"&@crlf&@crlf&"#AutoIt3Wrapper_UseX64=n"))
EndFunc
